#pragma once
#include "uart/ProtocolSender.h"

#include <entry/EasyUIContext.h>

#include <string>

static std::string last_input_content;

namespace { //匿名命名空间

class IMETextUpdateListener: public IMEContext::IIMETextUpdateListener {
public:
  virtual void onIMETextUpdate(const std::string &text) {
    LOGD("输入内容是 %s", text.c_str());
    //显示到TextView3
    mTextView3Ptr->setText(text);

    //保存输入的内容,方便列表获得内容显示
    last_input_content = text;
    //强制列表刷新
    mListView1Ptr->refreshListView();
  }

};

static IMETextUpdateListener ime_text_update_listener;
}



/**
 * 注册定时器
 * 填充数组用于注册定时器
 * 注意：id不能重复
 */
static S_ACTIVITY_TIMEER REGISTER_ACTIVITY_TIMER_TAB[] = {
	//{0,  6000}, //定时器id=0, 时间间隔6秒
	//{1,  1000},
};

/**
 * 当界面构造时触发
 */
static void onUI_init(){
    //Tips :添加 UI初始化的显示代码到这里,如:mText1Ptr->setText("123");

}

/**
 * 当切换到该界面时触发
 */
static void onUI_intent(const Intent *intentPtr) {
    if (intentPtr != NULL) {
        //TODO
    }
}

/*
 * 当界面显示时触发
 */
static void onUI_show() {

}

/*
 * 当界面隐藏时触发
 */
static void onUI_hide() {

}

/*
 * 当界面完全退出时触发
 */
static void onUI_quit() {

}

/**
 * 串口数据回调接口
 */
static void onProtocolDataUpdate(const SProtocolData &data) {

}

/**
 * 定时器触发函数
 * 不建议在此函数中写耗时操作，否则将影响UI刷新
 * 参数： id
 *         当前所触发定时器的id，与注册时的id相同
 * 返回值: true
 *             继续运行当前定时器
 *         false
 *             停止运行当前定时器
 */
static bool onUI_Timer(int id){
	switch (id) {

		default:
			break;
	}
    return true;
}

/**
 * 有新的触摸事件时触发
 * 参数：ev
 *         新的触摸事件
 * 返回值：true
 *            表示该触摸事件在此被拦截，系统不再将此触摸事件传递到控件上
 *         false
 *            触摸事件将继续传递到控件上
 */
static bool onmainActivityTouchEvent(const MotionEvent &ev) {
    switch (ev.mActionStatus) {
		case MotionEvent::E_ACTION_DOWN://触摸按下
			//LOGD("时刻 = %ld 坐标  x = %d, y = %d", ev.mEventTime, ev.mX, ev.mY);
			break;
		case MotionEvent::E_ACTION_MOVE://触摸滑动
			break;
		case MotionEvent::E_ACTION_UP:  //触摸抬起
			break;
		default:
			break;
	}
	return false;
}
static int getListItemCount_ListView1(const ZKListView *pListView) {
    //LOGD("getListItemCount_ListView1 !\n");
    return 5;
}

static void obtainListItemData_ListView1(ZKListView *pListView,ZKListView::ZKListItem *pListItem, int index) {
  pListItem->setText(last_input_content);
}

static void onListItemClick_ListView1(ZKListView *pListView, int index, int id) {
}

static bool onButtonClick_Button1(ZKButton *pButton) {
  static IMEContext::SIMETextInfo info;
  info.imeTextType = IMEContext::E_IME_TEXT_TYPE_NUMBER; //数字键盘
  info.isPassword = false; //非密码
  info.text = "";  //默认内容为空

  //showIME函数实现不同的平台有差异
#if 0   //  适用于Z11S,Z6,Z6s,A33平台
  EASYUICONTEXT->showIME(info, &ime_text_update_listener);
#endif

#if 1 //  适用于H500S,Z20,Z21,Z261,T113等平台
  EASYUICONTEXT->showIME(&info, &ime_text_update_listener);
#endif
  return false;
}

static bool onButtonClick_Button2(ZKButton *pButton) {
  static IMEContext::SIMETextInfo info;
  info.imeTextType = IMEContext::E_IME_TEXT_TYPE_ALL; //全键盘
  info.isPassword = false; //非密码
  info.text = "";  //默认内容为空
#if 0   //  适用于Z11S,Z6,Z6s,A33平台
  EASYUICONTEXT->showIME(info, &ime_text_update_listener);
#endif

#if 1 //  适用于H500S,Z20,Z21,Z261,T113等平台
  EASYUICONTEXT->showIME(&info, &ime_text_update_listener);
#endif
  return false;
}
